# recursion_practice_solutions.py
# Various sources: Labs from Spring 2022, old exams

import doll

def sum_to_num(n):
    """ Returns the value of the sum of numbers from 1 to up and including n
    Returns (1 + 2 + ... + n-1 + n).

    Precondition: n is a positive integer
    """
    sum = 1
    if n == 1:
        return 1
    else:
        return n + sum_to_num(n-1)

    # This function is a lot like factorial(). Can you see how the implement it?

def num_dolls(doll):
    """Returns: number of nesting dolls this doll contains, including itself.
    Example: if `doll` that contains one Doll in it, but that inner
    doll does not contain any Dolls, then this function returns 2.

    Precondition: doll is a Doll object (not None).
    """
    if  not doll.hasSeam:
        return 1
    else:
        return 1 + num_dolls(doll.innerDoll)
    # This function is from Lab 13

def embed(theinput):
    """Returns: depth of embedding, or nesting, in theinput.

    Examples:
        "the dog that barked" -> 0
        ["the", "dog", "that", "barked"] -> 1
        ["the" ["dog", "that", "barked"]] -> 2
        ["the" [[["dog"]], ["that", "barked"]] -> 3
        ["the" ["dog", ["that", ["barked"]] -> 4
        [[[["the"], "dog"], "that"], "barked"] -> 4

    Precondition: theinput is a string, or a potentially nested
    list of strings. No component list can be empty"""
    if type(theinput) != list:
        return 0
    else:
        accum = 1
        new = []
        for item in theinput:
            new.append(embed(item))
        newmax = max(new)
        return newmax + accum
    # This function is from the optional exercises of Lab 13.

def prefix(s):
    """Returns the prefix (identical characters at the start) length of s
    Example: prefix('abc') returns 1 as the prefix is 'a'
           prefix('xxxxxxyzx') returns 6 as the prefix is 'xxxxxx'
           prefix('') returns 0 as the string is empty
    Precondition: s is a (possibly empty) string of lowercase letters"""
    if s == '':
        return 0
    elif len(s) == 1:
        return 1
    left = prefix(s[0])
    right = prefix(s[1:])
    if s[0] == s[1]:
        return left+right
    return left
    # This function is 3(a) on Fall 2020, Prelim 2

def decode(nlist):
    """Returns a string that represents the decoded nlist
    The nlist is a list of lists, where each element is a character and
    a number. The number is the number of times to repeat the character.

    Example: decode([['a',3],['h',1],['a',1]]) is 'aaaha'
    Example: decode([]) is ''

    Precondition: nlist is a (possibly empty) nested list of two-element lists,
    where each list inside is a pair of a character and an integer"""
    if nlist == []:
        return ''
    pair = nlist[0]
    left = pair[0]*pair[1]

    right = decode(nlist[1:])
    return left+right
    # This function is question 3(a) from Fall 2018, Prelim 2
